#include <iostream>
#include <string>
#include <fstream>

#include <socklib.hpp>
#include <bufferedreaderwriter.hpp>
#include <regex>

/**
 * Affichage de l'erreur lorsque les paramètres ne sont pas bon
 * @param nom : doit être le nom du programme
 */
void usage(const std::string &nom)
{
    std::cerr << "## usage "
              << nom << " <mail_etudiant> <mail_prof> <serveur> <port>"
              << std::endl;
    exit(1);
}

/**
* Affiche de manière formatée la réponse complète du serveur
* @param text : text complet de la réponse
* @param code : le code d'erreur/reussite du message
* @param message : le messsage associé à la dernièr ligne
*/
void affiche_reponse(const std::string &text,
		     const std::string &code,
		     const std::string &message
		     ) {
  // on met des ## au début de chaque ligne
  static int num = 0;
  num += 1;
  std::ostringstream os;
  os << num;
  std::string snum = os.str();
  
  std::string ptext = "";
  uint deb = 0;
  uint fin = 0;
  while(true) {
    fin = text.find('\n', deb);
    if (fin == (uint) -1) {
      // il n'y a plus de \n
      if (deb < text.size()) {
	ptext.append("##"+snum+"-:"+text.substr(deb, text.size()-deb));
      }
      break;
    } else {
      // on a trouvé un \n
      ptext.append("##"+snum+"-: "+text.substr(deb, fin+1-deb));
      deb = fin+1;
    }
    
  }
  std::string reps;
  if (code.size()==0){
    reps = "KO";
  }
  else if (code[0]=='2') {
    reps = "OK";
  }
  else if (code[0]=='3') {
    reps = "...";
  } else {
    reps = "KO";
  }
    
  std::cout << "##"<<num<< ": Réponse du serveur " << reps << std::endl; 
  std::cout << "##"<<num<< ":                     le code est : " << code << std::endl
            << "##"<<num<< ":                  le message est : " << message << std::endl
            << "##"<<num<< ":         la réponse complète est : " << std::endl
            << ptext
            << "####################################################" << std::endl;



}

using namespace std;


void lire_rep(socklib::BufferedReaderWriter &serv, string &reponse, string &code, string &message)
{
    reponse = "";
    code = "";
    message = "";
    
    // CODE A FAIRE
}


int main(int argc, char* argv[])
{
    std::string nomcodeC = __FILE__;
    std::cerr << "## Le nom du fichier est " << nomcodeC << std::endl;

    // PARTIE DE CODE A FAIRE

    



    return 0;

}
